# How to use GetDataSetEx to retrieve customer information

You can use the [GetDataSetEx](/docs/api-reference/.net-api/qlmlicense/management-methods/getdatasetex.md) function to retrieve data from QLM tables.

The GetDataSetEx function allows you to specify a table and a filter to focus on the relevant data that you need to retrieve. To retrieve customer information, you should set the table argument to "qryCustomerInfo". The filter is similar to a SQL WHERE clause that uses any field in the Customer table.

In the example below, we demonstrate how to retrieve customers that were created after a specified date.

Note that GetDataSetEx is considered to be part of the [QLM Management API](/docs/api-reference/.net-api/qlmlicense/management-methods.md) and should **never** be called from within your application.

```csharp
private void GetCustomerInfo()
{
string dataSet = string.Empty;
string response = string.Empty;
string filter = String.Format("CreationDate > '2023-03-01'");

lv.QlmLicenseObject.GetDataSetEx(string.Empty, "qryCustomerInfo", filter, ref dataSet, out response);

ILicenseInfo licenseInfo = new LicenseInfo();
string message = string.Empty;

if (lv.QlmLicenseObject.ParseResults (response, ref licenseInfo, ref message))
{
    DataSet ds = new DataSet("NewDataSet");

    XmlReader reader = new XmlTextReader(dataSet, XmlNodeType.Document, null);

    if (!String.IsNullOrEmpty(dataSet))
    {
        ds.ReadXml(reader);
        if ((ds.Tables.Count > 0) && (ds.Tables[0].Rows.Count > 0))
        {
            DataRowCollection drc = ds.Tables[0].Rows;
            if (drc != null)
            {
                foreach (DataRow dr in drc)
                {
                    string email = dr["Email"].ToString();
                    Console.WriteLine(email);
                }
            }
        }
    }
}
}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.soraco.co/docs/how-to/how-to-use-getdatasetex-to-retrieve-customer-information.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
